<template>
  <v-list-item
    icon
    dense
    @click="() => uploader.click()"
  >
    <v-list-item-icon><v-icon>mdi-upload</v-icon></v-list-item-icon>
    <v-list-item-title id="import-button">
      {{ $t('button.import-sync') }}
    </v-list-item-title>
    <input
      ref="uploader"
      aria-labelledby="import-button"
      class="d-none"
      type="file"
      accept="application/json"
      hidden
      @change="load"
    >
  </v-list-item>
</template>

<script lang="ts">
import {
  Vue, Component, Ref,
} from 'vue-property-decorator';
import UnitParser from '@/formats/UnitParser';

@Component({})
export default class ImportSyncButton extends Vue {
  @Ref()
  uploader!: HTMLInputElement;

  async load() {
    const file = this.uploader?.files?.[0];

    if (!file) return;
    this.uploader.value = '';

    try {
      const format = JSON.parse(await file.text());
      // TODO: handle other types of sync
      const table = UnitParser.parseAudioTableFormat(format);

      this.$emit('replace-unit', table);
    } catch (e) {
      // TODO: warn user
      // eslint-disable-next-line no-console
      console.warn('Could not load file', file, 'error:', e);
    }
  }
}
</script>
